package edu.cmu.ece.drawe3.comm;

import java.io.DataInputStream;
import java.io.IOException;
import java.net.Socket;

import android.app.Activity;
import edu.cmu.ece.drawe3.render.OpenGLRenderer;
import edu.cmu.ece.drawe3.ui.Configuring;
import edu.cmu.ece.drawe3.ui.StatusReport;

public class PointReceiver extends Thread
{
	private final OpenGLRenderer openGLRenderer;
	private final Activity activity;
	
	final String hostname;
	int port = 1096;
	Socket socket = null;
	DataInputStream distream;
	StatusReport.Field sp;
	
	public PointReceiver(OpenGLRenderer openGLRenderer, String host, Activity activity, StatusReport.Field sp)
	{
		this.openGLRenderer = openGLRenderer;
		this.hostname = host;
		this.activity = activity;
		this.sp = sp;
		
		setDaemon(true);
	}
	
	private boolean connect()
	{
		this.openGLRenderer.points.clear();
		try
		{
			socket = new Socket(hostname, port);
			distream = new DataInputStream(socket.getInputStream());
			return true;
		}
		catch(Exception e)
		{
			System.out.println("Exception caught in connect().");
			e.printStackTrace();
			return false;
		}
	}
	
	public void run()
	{
		while(!Thread.interrupted())
		{
			sp.setVal("Connecting...");
			if (!connect())
			{
				sp.setVal("Connect failed");
				activity.runOnUiThread(new Runnable() {
					public void run() {
						activity.setResult(Configuring.CANT_CONNECT);
						activity.finish();
					}
				});
				break;
			}
			sp.setVal("Connected");
			try {
				while(!Thread.interrupted())
				{
					CoordPacket p = CoordPacket.fromByteStream(distream);
					if (p==null) continue;
					this.openGLRenderer.points.add_points(p);
					sp.setVal("Connected " + p.getSeq());
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
			//System.out.println("packets: " + i);
		}
	}
}