package edu.cmu.ece.drawe3.render;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.FloatBuffer;
import java.nio.IntBuffer;
import java.nio.ShortBuffer;
import java.util.ArrayList;
import javax.microedition.khronos.opengles.GL10;

import edu.cmu.ece.drawe3.comm.CoordPacket;

public class Points {

	ArrayList<int[]> p_list;
	ArrayList<Integer> id_list;
	ArrayList<Integer> seq_list;
	FloatBuffer vertexBuffer;
	ShortBuffer indexBuffer;
	IntBuffer colorBuffer;
	int max_id = 1; 
		
	int num_points ; 
	int index_size ;
	
	    public Points()
	    {
	    	num_points = 0;
	    	p_list = new ArrayList<int[]>();
	    	id_list = new ArrayList<Integer>();
	    	seq_list = new ArrayList<Integer>();
	    	
			// a float is 4 bytes, therefore we multiply the number if
			// vertices with 4.
			ByteBuffer vbb = ByteBuffer.allocateDirect(0);
			vbb.order(ByteOrder.nativeOrder());
			vertexBuffer = vbb.asFloatBuffer();
			vertexBuffer.position(0);

			// short is 2 bytes, therefore we multiply the number if
			// vertices with 2.
			ByteBuffer ibb = ByteBuffer.allocateDirect(0);
			ibb.order(ByteOrder.nativeOrder());
			indexBuffer = ibb.asShortBuffer();
			indexBuffer.position(0);
			
		    ByteBuffer cbb = ByteBuffer.allocateDirect(0);
	        cbb.order(ByteOrder.nativeOrder());
	        colorBuffer = cbb.asIntBuffer();
	       // colorBuffer.put(colors);
	        colorBuffer.position(0);
	
			
	    }
	    
	    public void clear() {
			num_points = 0;
			p_list.clear();
			id_list.clear();
			seq_list.clear();
			vertexBuffer.clear();
			indexBuffer.clear();
			colorBuffer.clear();
			max_id = 1; 
		}

	    public synchronized void add_points(CoordPacket p){
	    	int[] arr;
	    	
	    	for(int i = 0; i<p.getSize(); i++){
	    		arr = p.getPoint(i);
	    		
	    		System.out.println(num_points + ":   x: " + arr[0] + "  y: " + arr[1] + "  z: " + arr[2]);
	    		
	    		num_points += 1;
	    		p_list.add(arr);
	    		int id = p.getControllerId();
	    		if(max_id < id) max_id = id;
	    		id_list.add(p.getControllerId());
	    		seq_list.add(p.getSeq());
	    	}
	    	
	    	float[] points = new float[num_points*3];
	    	ArrayList<Integer> ind = new ArrayList<Integer>();
	    	
	    	//short[] index = new short[num_points];
	    	
	    	int seg = 0;
	    	int ind_ind = 0;
	    	for(int i = 0; i<3*num_points; i+=3){
	    		//load up the points
	    		int[] temparr = p_list.get(i/3);
	    		points[i] = 300f*(temparr[0]-320)/320f;
	    		points[i+1] = temparr[2]-400;
	    		points[i+2] = -225f*(temparr[1]-240)/240f;
	    		
	    		if(i==0) continue;
	    		
	    		//now check the seq number
	    		
	    		if(seq_list.get(i/3)==seg){
	    			//joined: add pair: prev and current
	    			int pp = i/3 - 1;
	    			ind.add(pp);
	    			ind_ind++;
	    			ind.add(i/3);
	    			ind_ind++;
	    //			prevpoint = -1;
	    		}
	    		else{
	    			seg = seq_list.get(i/3);
	    			//not joined: so just add one point
	    	//		ind.add(ind.get(ind_ind-1)+1);
	    		//	ind_ind++;
	    			
	    		}
	    	}
	    	
	    	short[] index = new short[ind_ind];
	    	for(int i = 0; i< ind_ind; i++){
	    		index[i] = (ind.get(i).shortValue());
	    	}
	    	index_size = ind_ind;
	    	
	    	
	    //	int count=0;
	    	//load all the points
	  /*  	for (int i = 0; i<p_list.size(); i++){
	    		int[] curr = p_list.get(i);
	    	//	System.out.println(Arrays.toString(curr));
	    		for(int j = 0; j<curr.length; j++){
	    			//assume points are [500, 1000]
	    			points[count] = curr[j];
	    			if((j)%3 == 0) points[count] = 1.6f*(points[count]-320)/320.0f;
	    			if((j+2)%3 == 0) points[count] = 1f*(points[count]-240)/240.0f;
	    			if((j+1)%3 == 0) points[count] = 0;
	    			count++;
	    		}
	    	}
	    */	
	    	//short temp = 0;
	    //	for(short i= 0; i<num_points; i++) index[i] = i;
	    	
	    //	index = new short[] { 0, 1, 2, 0, 2, 3 };
	//    	System.out.println(Arrays.toString(points));
	  //  	System.out.println(Arrays.toString(index));
	    	
			// a float is 4 bytes, therefore we multiply the number if
			// vertices with 4.
			ByteBuffer vbb = ByteBuffer.allocateDirect(points.length * 4);
			vbb.order(ByteOrder.nativeOrder());
			vertexBuffer = vbb.asFloatBuffer();
			vertexBuffer.put(points);
			vertexBuffer.position(0);

			// short is 2 bytes, therefore we multiply the number if
			// vertices with 2.
			ByteBuffer ibb = ByteBuffer.allocateDirect(index.length * 2);
			ibb.order(ByteOrder.nativeOrder());
			indexBuffer = ibb.asShortBuffer();  
			indexBuffer.put(index);
			indexBuffer.position(0);
	    }

	    public synchronized void draw(GL10 gl)
	    {

			
	    	if(num_points==0) return; 
	    	
			// Counter-clockwise winding.
			gl.glFrontFace(GL10.GL_CCW); // OpenGL docs
			// Enable face culling.
			gl.glEnable(GL10.GL_CULL_FACE); // OpenGL docs
			// What faces to remove with the face culling.
			gl.glCullFace(GL10.GL_BACK); // OpenGL docs

			// Enabled the vertices buffer for writing and to be used during
			// rendering.
			gl.glEnableClientState(GL10.GL_VERTEX_ARRAY);// OpenGL docs.
			// Specifies the location and data format of an array of vertex
			// coordinates to use when rendering.
			
			
			gl.glLineWidth(3);
	        gl.glVertexPointer(3, GL10.GL_FLOAT, 0, vertexBuffer);
	        gl.glDrawElements(GL10.GL_LINES,index_size, GL10.GL_UNSIGNED_SHORT,indexBuffer);
	        

			// Disable the vertices buffer.
			gl.glDisableClientState(GL10.GL_VERTEX_ARRAY); // OpenGL docs
			// Disable face culling.
			gl.glDisable(GL10.GL_CULL_FACE); // OpenGL docs
	    }

	}

