package edu.cmu.ece.drawe3.tracking.nyartk;

import jp.nyatla.nyartoolkit.NyARException;
import jp.nyatla.nyartoolkit.core.raster.NyARRaster_BasicClass;
import jp.nyatla.nyartoolkit.core.raster.rgb.INyARRgbRaster;
import jp.nyatla.nyartoolkit.core.rasterreader.INyARRgbPixelReader;
import jp.nyatla.nyartoolkit.core.types.NyARBufferType;

class AndroidARRaster extends NyARRaster_BasicClass implements INyARRgbRaster
{
	private byte[] _buffer;
	private NyARRgbPixelReader_BYTE1D_GRAY_8 _reader;
	
	public class NyARRgbPixelReader_BYTE1D_GRAY_8 implements INyARRgbPixelReader
	{
		public void getPixel(int i_x, int i_y, int[] o_rgb)
				throws NyARException {
			o_rgb[0] = o_rgb[1]=o_rgb[2]=AndroidARRaster.this._buffer[i_x + i_y * AndroidARRaster.this.getWidth()] & 0xff;
		}

		public void getPixelSet(int[] i_x, int[] i_y, int i_num, int[] o_rgb)
				throws NyARException {
			final int width = AndroidARRaster.this.getWidth();
			final byte[] ref_buf = AndroidARRaster.this._buffer;
			for (int i = i_num - 1; i >= 0; i--){
				o_rgb[i * 3 + 0] = o_rgb[i * 3 + 1]=o_rgb[i * 3 + 2]=((int)ref_buf[i_x[i] + i_y[i] * width]) & 0xff;
			}
		}

		public void setPixel(int i_x, int i_y, int i_r, int i_g, int i_b)
				throws NyARException {
			NyARException.notImplement();
		}

		public void setPixel(int i_x, int i_y, int[] i_rgb)
				throws NyARException {
			NyARException.notImplement();
		}

		public void setPixels(int[] i_x, int[] i_y, int i_num, int[] i_intrgb)
				throws NyARException {
			NyARException.notImplement();
		}

		public void switchBuffer(Object i_ref_buffer) throws NyARException {
			NyARException.notImplement();
		}
		
	}
	
	public AndroidARRaster(int i_width, int i_height)
	{
		super(i_width, i_height, NyARBufferType.BYTE1D_GRAY_8);
		this._buffer= null;
		this._reader = new NyARRgbPixelReader_BYTE1D_GRAY_8();
	}

	public Object getBuffer() {
		assert _buffer != null;
		return _buffer;
	}

	public boolean hasBuffer() {
		return _buffer != null;
	}

	public void wrapBuffer(Object i_ref_buf) throws NyARException {
		_buffer = (byte[])i_ref_buf;
	}

	public INyARRgbPixelReader getRgbPixelReader() throws NyARException {
		return _reader;
	}
}