package edu.cmu.ece.drawe3.tracking.nyartk;

import jp.nyatla.nyartoolkit.NyARException;
import jp.nyatla.nyartoolkit.core.param.NyARParam;
import jp.nyatla.nyartoolkit.core.types.NyARIntSize;

public class SingleNyIdMarker
{
	private NyARParam _ar_param;
	
	private AndroidARRaster _cap_image;
	
	private MarkerProcessor _processor;

	public SingleNyIdMarker(NyARParam i_cparam, int marker_size) throws NyARException
	{
		this._ar_param=i_cparam;
		
		NyARIntSize size = this._ar_param.getScreenSize();
		this._cap_image = new AndroidARRaster(size.w, size.h);
		
		this._processor=new MarkerProcessor(this._ar_param,marker_size,this._cap_image.getBufferType());
	}
	
	public int updateBuffer(byte[] i_buffer)
	{
		try {
			this._cap_image.wrapBuffer(i_buffer);
			
			this._processor.detectMarker(this._cap_image);
			
			System.out.println("ID: " + this._processor.current_id);
			
			return this._processor.current_id;
		} catch (Exception e) {
			e.printStackTrace();
			return -1;
		}
	}
	
	public double[] getModelView()
	{
		if (this._processor != null || this._processor.current_id != -1)
			return this._processor.getGLTransform();
		else
			return null;
	}
}