package edu.cmu.ece.drawe3.ui;

import edu.cmu.ece.drawe3.R;
import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ScrollView;
import android.widget.TextView;

public class Configuring extends Activity {

	public static final int CANT_CONNECT = Activity.RESULT_FIRST_USER;

	private SharedPreferences prefs;
	private TextView serverIP;
	
	@Override
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		
		setContentView(R.layout.main);
		
		prefs = getPreferences(MODE_WORLD_WRITEABLE);
		
		serverIP = (TextView) findViewById(R.id.serverIP);
		
		Button launchButton = (Button) findViewById(R.id.goButton);
		launchButton.setOnClickListener(new OnClickListener() {
			public void onClick(View view) {
				Intent intent = new Intent(view.getContext(), Tracking.class);
				intent.putExtra("serverIP", serverIP.getText().toString());
				startActivityForResult(intent, 0);
			}
		});
		
		serverIP.setText(prefs.getString("serverIP", getString(R.string.default_IP)));
	}
	
	protected void onPause()
	{
		super.onPause();
		
		prefs.edit().putString("serverIP", serverIP.getText().toString()).commit();
	}
	
	protected void onActivityResult(int requestCode, int resultCode, Intent data)
	{
		TextView errorText = (TextView) findViewById(R.id.errorText);
		
		switch(resultCode)
		{
		case Activity.RESULT_OK:
			errorText.setText("");
			return;
		case Activity.RESULT_CANCELED:
			errorText.setText("Unknown error");
			break;
		case Configuring.CANT_CONNECT:
			errorText.setText("Error: can't connect to server");
			break;
		}
		((ScrollView) findViewById(R.id.topScroll)).scrollTo(0, errorText.getBottom());
	}
}
