package edu.cmu.ece.drawe3.ui;

import android.content.Context;
import android.graphics.Color;
import android.widget.TextView;

public class StatusReport extends TextView
{
	public class Field
	{
		private String val;
		
		public Field()
		{
			this("");
		}
		public Field(String initial)
		{
			this.val = initial;
		}
		public void setVal(String newVal)
		{
			this.val = newVal;
			StatusReport.this.updateDisplay();
		}
		public String toString()
		{
			return val;
		}
	}
	
	private Field[] fields;
	
	public StatusReport(Context c, int numFields)
	{
		super(c);
		setTextColor(Color.WHITE);
		
		this.fields = new Field[numFields];
		for(int i = 0; i < fields.length; i++)
			this.fields[i] = new Field();
	}
	
	public Field getField(int n)
	{
		return fields[n];
	}
	
	public void updateField(int n, String str)
	{
		fields[n].setVal(str);
	}
	
	protected void updateDisplay()
	{
		final StringBuilder sb = new StringBuilder();
		for(Field s : fields)
			sb.append(s).append("    ");
		this.post(new Runnable() {
			public void run() {
				StatusReport.this.setText(sb);
			}
		});
	}
}