package edu.cmu.ece.drawe3.ui;

import java.io.File;
import java.io.IOException;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Arrays;
import android.app.Activity;
import android.content.ContextWrapper;
import android.graphics.PixelFormat;
import android.opengl.GLSurfaceView;
import android.os.Bundle;
import android.os.PowerManager;
import android.os.PowerManager.WakeLock;
import android.view.Display;
import android.view.MenuItem;
import android.view.ViewGroup;
import android.view.WindowManager;

import edu.cmu.ece.drawe3.render.D3Renderer;
import edu.cmu.ece.drawe3.render.OpenGLRenderer;
import edu.cmu.ece.drawe3.render.StaticRenderer;
import edu.cmu.ece.drawe3.tracking.TrackingHandler;

public class Tracking extends Activity {
	
	String hostname;
	//hostname = "192.168.0.101"
	//hostname = "128.237.239.84"
	//hostname = "192.168.2.102"
	//hostname = "CMU-380343.WV.CC.CMU.EDU"
	
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        hostname = getIntent().getStringExtra("serverIP");
        cachePath = getCacheDir();
        
        StatusReport sp = new StatusReport(this, 4);
        
        mGLSurfaceView = new GLSurfaceView(this);
        mGLSurfaceView.setEGLConfigChooser(8, 8, 8, 8, 16, 0);
        mRenderer = new OpenGLRenderer(this, hostname, sp.getField(1));

        /*try {
        	URL url = new URL("http", hostname, 80, "/open_cube.obj");
			HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
			try {
				mRenderer.load_points(urlConnection.getInputStream());
			} finally {
				urlConnection.disconnect();
			}
		} catch (IOException e) {
			e.printStackTrace();
		}*/
        
        mGLSurfaceView.setRenderer(mRenderer);
        mGLSurfaceView.getHolder().setFormat(PixelFormat.TRANSLUCENT);
        addContentView(mGLSurfaceView, new ViewGroup.LayoutParams(ViewGroup.LayoutParams.FILL_PARENT, ViewGroup.LayoutParams.FILL_PARENT));

        mDisplay = ((WindowManager)getSystemService(WINDOW_SERVICE)).getDefaultDisplay();
        mWakeLock = ((PowerManager)getSystemService(POWER_SERVICE)).newWakeLock(PowerManager.SCREEN_BRIGHT_WAKE_LOCK, getClass().getName());

        new TrackingHandler(this, hostname, sp.getField(0));
		
		addContentView(sp, new ViewGroup.LayoutParams(ViewGroup.LayoutParams.FILL_PARENT, ViewGroup.LayoutParams.FILL_PARENT));
    }
    
    public void onBackPressed()
    {
    	setResult(Activity.RESULT_OK);
    	finish();
    }
    
    public void setTransform(float[] _trans) {
    	mRenderer.setModelView(_trans);
    	System.out.println(Arrays.toString(_trans));
    }
    
    public void setProjection(float[] projectionMatrix) {
		mRenderer.setProjection(projectionMatrix);
		System.out.println(Arrays.toString(projectionMatrix));
	}
    
    public boolean onOptionsItemSelected (MenuItem item)
    {
    	return false;
    }

    @Override
    protected void onResume() {
        super.onResume();
        /*
         * when the activity is resumed, we acquire a wake-lock so that the
         * screen stays on, since the user will likely not be fiddling with the
         * screen or buttons.
         */
        mWakeLock.acquire();
        mGLSurfaceView.onResume();
        //mInertialTracker.onResume();
    }

    @Override
    protected void onPause() {
        super.onPause();
        mGLSurfaceView.onPause();
        //mInertialTracker.onPause();
        mWakeLock.release();
    }
    
    public int getOrientation()
    {
    	return mDisplay.getOrientation();
    }

    private GLSurfaceView mGLSurfaceView;
    //private CubeRenderer mCubeRenderer;
    private D3Renderer mRenderer;
	//private InertialTracker mInertialTracker;
    private Display mDisplay;
	private WakeLock mWakeLock;
	
	private static File cachePath = null;

	public static File getCachePath() {
		return cachePath;
	}
}
